Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman17.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman17.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman17.cs	(revision 17642)
@@ -1,34 +1,49 @@
-﻿using System;
+using System;
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-using HeuristicLab.Common;
 using HeuristicLab.Random;
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Feynman17 : FeynmanDescriptor{
- public override string Name { get { return "Feynman I.15.3x x1 = (x-u*t)/sqrt(1-u^2/c^2)"; } }
+  public class Feynman17 : FeynmanDescriptor {
+    private readonly int testSamples;
+    private readonly int trainingSamples;
 
- protected override string TargetVariable { get { return "x1"; } }
-    protected override string[] VariableNames { get { return new string[] { "x", "u", "c", "t", "x1"}; } }
-    protected override string[] AllowedInputVariables { get { return new string[] {"x", "u", "c", "t"}; } }
+    public Feynman17() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman17(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman17(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get { return string.Format("Feynman I.15.3x (x-u*t)/sqrt(1-u**2/c**2) | {0} samples", trainingSamples); }
+    }
+
+    protected override string TargetVariable { get { return "x1"; } }
+    protected override string[] VariableNames { get { return new[] {"x", "u", "c", "t", "x1"}; } }
+    protected override string[] AllowedInputVariables { get { return new[] {"x", "u", "c", "t"}; } }
 
     public int Seed { get; private set; }
 
-    public Feynman17() : this((int)System.DateTime.Now.Ticks) { }
-
-    public Feynman17(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
-      var rand = new MersenneTwister((uint)Seed);
+      var rand = new MersenneTwister((uint) Seed);
 
       var data = new List<List<double>>();
-      var x = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 5, 10).ToList();
-      var u = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 2).ToList();
-      var c = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 3, 20).ToList();
-      var t = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 2).ToList();
+      var x    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 5, 10).ToList();
+      var u    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 2).ToList();
+      var c    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 3, 20).ToList();
+      var t    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 2).ToList();
 
       var x1 = new List<double>();
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman18.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman18.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman18.cs	(revision 17642)
@@ -1,34 +1,49 @@
-﻿using System;
+using System;
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-using HeuristicLab.Common;
 using HeuristicLab.Random;
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Feynman18 : FeynmanDescriptor{
- public override string Name { get { return "Feynman I.15.3t t1 = (t-u*x/c^2)/sqrt(1-u^2/c^2)"; } }
+  public class Feynman18 : FeynmanDescriptor {
+    private readonly int testSamples;
+    private readonly int trainingSamples;
 
- protected override string TargetVariable { get { return "t1"; } }
-    protected override string[] VariableNames { get { return new string[] { "x", "c", "u", "t", "t1"}; } }
-    protected override string[] AllowedInputVariables { get { return new string[] {"x", "c", "u", "t"}; } }
+    public Feynman18() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman18(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman18(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get { return string.Format("Feynman I.15.3t (t-u*x/c**2)/sqrt(1-u**2/c**2) | {0} samples", trainingSamples); }
+    }
+
+    protected override string TargetVariable { get { return "t1"; } }
+    protected override string[] VariableNames { get { return new[] {"x", "c", "u", "t", "t1"}; } }
+    protected override string[] AllowedInputVariables { get { return new[] {"x", "c", "u", "t"}; } }
 
     public int Seed { get; private set; }
 
-    public Feynman18() : this((int)System.DateTime.Now.Ticks) { }
-
-    public Feynman18(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
-      var rand = new MersenneTwister((uint)Seed);
+      var rand = new MersenneTwister((uint) Seed);
 
       var data = new List<List<double>>();
-      var x = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var c = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 3, 10).ToList();
-      var u = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 2).ToList();
-      var t = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var x    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var c    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 3, 10).ToList();
+      var u    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 2).ToList();
+      var t    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
 
       var t1 = new List<double>();
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman19.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman19.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman19.cs	(revision 17642)
@@ -1,33 +1,48 @@
-﻿using System;
+using System;
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-using HeuristicLab.Common;
 using HeuristicLab.Random;
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Feynman19 : FeynmanDescriptor{
- public override string Name { get { return "Feynman I.15.1 p = m_0*v/sqrt(1-v^2/c^2)"; } }
+  public class Feynman19 : FeynmanDescriptor {
+    private readonly int testSamples;
+    private readonly int trainingSamples;
 
- protected override string TargetVariable { get { return "p"; } }
-    protected override string[] VariableNames { get { return new string[] { "m_0", "v", "c", "p"}; } }
-    protected override string[] AllowedInputVariables { get { return new string[] {"m_0", "v", "c"}; } }
+    public Feynman19() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman19(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman19(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get { return string.Format("Feynman I.15.1 m_0*v/sqrt(1-v**2/c**2) | {0} samples", trainingSamples); }
+    }
+
+    protected override string TargetVariable { get { return "p"; } }
+    protected override string[] VariableNames { get { return new[] {"m_0", "v", "c", "p"}; } }
+    protected override string[] AllowedInputVariables { get { return new[] {"m_0", "v", "c"}; } }
 
     public int Seed { get; private set; }
 
-    public Feynman19() : this((int)System.DateTime.Now.Ticks) { }
-
-    public Feynman19(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
-      var rand = new MersenneTwister((uint)Seed);
+      var rand = new MersenneTwister((uint) Seed);
 
       var data = new List<List<double>>();
-      var m_0 = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var v = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 2).ToList();
-      var c = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 3, 10).ToList();
+      var m_0  = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var v    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 2).ToList();
+      var c    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 3, 10).ToList();
 
       var p = new List<double>();
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman2.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman2.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman2.cs	(revision 17642)
@@ -1,45 +1,61 @@
-﻿using System;
+using System;
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-using HeuristicLab.Common;
 using HeuristicLab.Random;
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Feynman2 : FeynmanDescriptor{
- public override string Name { get { return "Feynman I.6.2a f = exp(-(theta/sigma)^2)/2)/sqrt(2*pi)*sigma)"; } }
+  public class Feynman2 : FeynmanDescriptor {
+    private readonly int testSamples;
+    private readonly int trainingSamples;
 
- protected override string TargetVariable { get { return "f"; } }
-    protected override string[] VariableNames { get { return new string[] { "sigma", "theta", "f"}; } }
-    protected override string[] AllowedInputVariables { get { return new string[] { "sigma", "theta" }; } }
+    public Feynman2() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman2(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman2(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get {
+        return string.Format("Feynman I.6.2 exp(-(theta/sigma)**2/2)/(sqrt(2*pi)*sigma) | {0} samples",
+          trainingSamples);
+      }
+    }
+
+    protected override string TargetVariable { get { return "f"; } }
+    protected override string[] VariableNames { get { return new[] {"sigma", "theta", "f"}; } }
+    protected override string[] AllowedInputVariables { get { return new[] {"sigma", "theta"}; } }
 
     public int Seed { get; private set; }
 
-    public Feynman2() : this((int)System.DateTime.Now.Ticks) { }
-
-    public Feynman2(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
-      var rand = new MersenneTwister((uint)Seed);
+      var rand = new MersenneTwister((uint) Seed);
 
-      var data = new List<List<double>>();
+      var data  = new List<List<double>>();
+      var sigma = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 3).ToList();
       var theta = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 3).ToList();
-      var sigma = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 3).ToList();
 
       var f = new List<double>();
 
+      data.Add(sigma);
       data.Add(theta);
-      data.Add(sigma);
       data.Add(f);
 
-
-      for (var i = 0; i < theta.Count; i++) {
+      for (var i = 0; i < sigma.Count; i++) {
         var res = Math.Exp(-Math.Pow(theta[i] / sigma[i], 2) / 2) / (Math.Sqrt(2 * Math.PI) * sigma[i]);
         f.Add(res);
       }
-
 
       return data;
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman20.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman20.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman20.cs	(revision 17642)
@@ -1,33 +1,48 @@
-﻿using System;
+using System;
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-using HeuristicLab.Common;
 using HeuristicLab.Random;
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Feynman20 : FeynmanDescriptor{
- public override string Name { get { return "Feynman I.16.6 v1 = (u+v)/(1+u*v/c^2)"; } }
+  public class Feynman20 : FeynmanDescriptor {
+    private readonly int testSamples;
+    private readonly int trainingSamples;
 
- protected override string TargetVariable { get { return "v1"; } }
-    protected override string[] VariableNames { get { return new string[] { "c", "v", "u", "v1"}; } }
-    protected override string[] AllowedInputVariables { get { return new string[] {"c", "v", "u"}; } }
+    public Feynman20() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman20(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman20(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get { return string.Format("Feynman I.16.6 (u+v)/(1+u*v/c**2) | {0} samples", trainingSamples); }
+    }
+
+    protected override string TargetVariable { get { return "v1"; } }
+    protected override string[] VariableNames { get { return new[] {"c", "v", "u", "v1"}; } }
+    protected override string[] AllowedInputVariables { get { return new[] {"c", "v", "u"}; } }
 
     public int Seed { get; private set; }
 
-    public Feynman20() : this((int)System.DateTime.Now.Ticks) { }
-
-    public Feynman20(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
-      var rand = new MersenneTwister((uint)Seed);
+      var rand = new MersenneTwister((uint) Seed);
 
       var data = new List<List<double>>();
-      var c = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var v = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var u = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var c    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var v    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var u    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
 
       var v1 = new List<double>();
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman21.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman21.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman21.cs	(revision 17642)
@@ -1,34 +1,49 @@
-﻿using System;
+using System;
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-using HeuristicLab.Common;
 using HeuristicLab.Random;
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Feynman21 : FeynmanDescriptor{
- public override string Name { get { return "Feynman I.18.4 r = (m1*r1+m2*r2)/(m1+m2)"; } }
+  public class Feynman21 : FeynmanDescriptor {
+    private readonly int testSamples;
+    private readonly int trainingSamples;
 
- protected override string TargetVariable { get { return "r"; } }
-    protected override string[] VariableNames { get { return new string[] { "m1", "m2", "r1", "r2", "r"}; } }
-    protected override string[] AllowedInputVariables { get { return new string[] {"m1", "m2", "r1", "r2"}; } }
+    public Feynman21() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman21(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman21(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get { return string.Format("Feynman I.18.4 (m1*r1+m2*r2)/(m1+m2) | {0} samples", trainingSamples); }
+    }
+
+    protected override string TargetVariable { get { return "r"; } }
+    protected override string[] VariableNames { get { return new[] {"m1", "m2", "r1", "r2", "r"}; } }
+    protected override string[] AllowedInputVariables { get { return new[] {"m1", "m2", "r1", "r2"}; } }
 
     public int Seed { get; private set; }
 
-    public Feynman21() : this((int)System.DateTime.Now.Ticks) { }
-
-    public Feynman21(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
-      var rand = new MersenneTwister((uint)Seed);
+      var rand = new MersenneTwister((uint) Seed);
 
       var data = new List<List<double>>();
-      var m1 = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var m2 = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var r1 = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var r2 = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var m1   = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var m2   = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var r1   = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var r2   = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
 
       var r = new List<double>();
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman22.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman22.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman22.cs	(revision 17642)
@@ -1,32 +1,47 @@
-﻿using System;
+using System;
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-using HeuristicLab.Common;
 using HeuristicLab.Random;
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Feynman22 : FeynmanDescriptor{
- public override string Name { get { return "Feynman I.18.12 tau = (m1*r1+m2*r2)/(m1+m2)"; } }
+  public class Feynman22 : FeynmanDescriptor {
+    private readonly int testSamples;
+    private readonly int trainingSamples;
 
- protected override string TargetVariable { get { return "tau"; } }
-    protected override string[] VariableNames { get { return new string[] { "r", "F", "theta", "tau"}; } }
-    protected override string[] AllowedInputVariables { get { return new string[] {"r", "F", "theta"}; } }
+    public Feynman22() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman22(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman22(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get { return string.Format("Feynman I.18.12 r*F*sin(theta) | {0} samples", trainingSamples); }
+    }
+
+    protected override string TargetVariable { get { return "tau"; } }
+    protected override string[] VariableNames { get { return new[] {"r", "F", "theta", "tau"}; } }
+    protected override string[] AllowedInputVariables { get { return new[] {"r", "F", "theta"}; } }
 
     public int Seed { get; private set; }
 
-    public Feynman22() : this((int)System.DateTime.Now.Ticks) { }
-
-    public Feynman22(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
-      var rand = new MersenneTwister((uint)Seed);
+      var rand = new MersenneTwister((uint) Seed);
 
-      var data = new List<List<double>>();
-      var r = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var F = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var data  = new List<List<double>>();
+      var r     = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var F     = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
       var theta = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 0, 5).ToList();
 
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman23.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman23.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman23.cs	(revision 17642)
@@ -1,33 +1,48 @@
-﻿using System;
+using System;
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-using HeuristicLab.Common;
 using HeuristicLab.Random;
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Feynman23 : FeynmanDescriptor{
- public override string Name { get { return "Feynman I.18.14 L = m*r*v*sin(theta)"; } }
+  public class Feynman23 : FeynmanDescriptor {
+    private readonly int testSamples;
+    private readonly int trainingSamples;
 
- protected override string TargetVariable { get { return "L"; } }
-    protected override string[] VariableNames { get { return new string[] { "m", "r", "v", "theta", "L"}; } }
-    protected override string[] AllowedInputVariables { get { return new string[] {"m", "r", "v", "theta"}; } }
+    public Feynman23() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman23(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman23(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get { return string.Format("Feynman I.18.14 m*r*v*sin(theta) | {0} samples", trainingSamples); }
+    }
+
+    protected override string TargetVariable { get { return "L"; } }
+    protected override string[] VariableNames { get { return new[] {"m", "r", "v", "theta", "L"}; } }
+    protected override string[] AllowedInputVariables { get { return new[] {"m", "r", "v", "theta"}; } }
 
     public int Seed { get; private set; }
 
-    public Feynman23() : this((int)System.DateTime.Now.Ticks) { }
-
-    public Feynman23(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
-      var rand = new MersenneTwister((uint)Seed);
+      var rand = new MersenneTwister((uint) Seed);
 
-      var data = new List<List<double>>();
-      var m = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var r = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var v = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var data  = new List<List<double>>();
+      var m     = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var r     = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var v     = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
       var theta = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
 
@@ -37,7 +52,8 @@
       data.Add(r);
       data.Add(v);
+      data.Add(theta);
       data.Add(L);
 
-      for (var i = 0; i < r.Count; i++) {
+      for (var i = 0; i < m.Count; i++) {
         var res = m[i] * r[i] * v[i] * Math.Sin(theta[i]);
         L.Add(res);
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman24.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman24.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman24.cs	(revision 17642)
@@ -6,5 +6,26 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Feynman24 : FeynmanDescriptor {
-    public override string Name { get { return "Feynman I.24.6 1/2*m*(omega**2+omega_0**2)*1/2*x**2"; } }
+    private readonly int testSamples;
+    private readonly int trainingSamples;
+
+    public Feynman24() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman24(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman24(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get {
+        return string.Format("Feynman I.24.6 1/2*m*(omega**2+omega_0**2)*1/2*x**2 | {0} samples", trainingSamples);
+      }
+    }
 
     protected override string TargetVariable { get { return "E_n"; } }
@@ -14,9 +35,8 @@
     public int Seed { get; private set; }
 
-    public Feynman24() : this((int) DateTime.Now.Ticks) { }
-
-    public Feynman24(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
